<template>
  <div>
    <overlay :overlay="overlay" />
    <v-data-table
      v-bind="$attrs"
      :search="search"
      :no-data-text="noDataText"
      :no-results-text="$t('noResultsText')"
      :footer-props="{
        itemsPerPageText: $t('itemsPerPageText'),
        itemsPerPageAllText: $t('itemsPerPageAllText'),
      }"
      v-on="$listeners"
    >
      <template v-slot:top>
        <actions-container
          v-if="!hideSlotTop"
          :columns-to-show="columnsToShow"
        >
          <template v-slot:search>
            <search-field
              v-model="search"
              :placeholder="searchPlaceholder"
            />
          </template>
          <template v-slot:create>
            <slot name="create" />
          </template>
          <template v-slot:columnsToShow>
            <slot name="columnsToShow" />
          </template>
        </actions-container>
        <slot name="confirmationToDelete" />
        <slot name="update" />
      </template>

      <template
        v-for="header in $attrs.headers"
        v-slot:[dynamicSlotName(header)]="props"
      >
        <slot
          :name="header.value"
          v-bind="props"
        >
          {{ props.item[header.value] }}
        </slot>
      </template>

      <template v-slot:item.data-table-expand="{ expand, isExpanded }">
        <v-btn
          text
          icon
          @click="expand(!isExpanded)"
        >
          <is-collapsed-icon :is-collapsed="isExpanded" />
        </v-btn>
      </template>

      <template v-slot:expanded-item="{ headers, item }">
        <expanded-item-container :colspan="headers.length">
          <slot
            name="collapse"
            v-bind="item"
          />
        </expanded-item-container>
      </template>
    </v-data-table>
  </div>
</template>

<script>
  import ActionsContainer from './components/ActionsContainer'
  import ExpandedItemContainer from './components/ExpandedItemContainer'

  export default {
    name: 'CrudDataTable',
    components: {
      ActionsContainer,
      ExpandedItemContainer,
    },
    inheritAttrs: false,
    props: {
      searchPlaceholder: {
        type: String,
        required: false,
      },
      noDataMessage: {
        type: String,
        required: false,
      },
      overlay: {
        type: Boolean,
        required: false,
        default: false,
      },
      hideSlotTop: {
        type: Boolean,
        required: false,
        default: false,
      },
      columnsToShow: {
        type: Boolean,
        required: false,
        default: false,
      },
    },
    data () {
      return {
        search: '',
      }
    },
    computed: {
      noDataText () {
        return this.noDataMessage ? this.noDataMessage : this.$t('noDataText')
      },
    },
    methods: {
      dynamicSlotName (header) {
        return 'item.' + header.value
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          noDataText: 'Nenhum registro para exibir.',
          noResultsText: 'Sua pesquisa não retornou resultados.',
          itemsPerPageAllText: 'Todos',
          itemsPerPageText: 'Itens por página',
        },
        'en-US': {
          noDataText: 'No records to display.',
          noResultsText: 'No matching records found.',
          itemsPerPageAllText: 'All',
          itemsPerPageText: 'Rows per page',
        },
      },
    },
  }
</script>
